<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.4//EN" "http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
<refentry id='routino-router-slim'>

  <refmeta>
    <refentrytitle>routino-router-slim</refentrytitle>
    <manvolnum>1</manvolnum>
  </refmeta>

  <refnamediv>
    <refname>routino-router-slim</refname>
    <refpurpose>calculate routes using the routino database</refpurpose>
  </refnamediv>

  <refsynopsisdiv id='synopsis'>
    <cmdsynopsis>
      <command>routino-router-slim</command>
      <arg choice='opt'><option>--version</option></arg>
      <group>
        <arg choice='opt'><option>--help</option></arg>
        <arg choice='opt'><option>--help-profile-xml</option></arg>
        <arg choice='opt'><option>--help-profile-json</option></arg>
        <arg choice='opt'><option>--help-profile-perl</option></arg>
      </group>
      <arg choice='opt'><option>--dir=<replaceable>dirname</replaceable></option></arg>
      <arg choice='opt'><option>--prefix=<replaceable>name</replaceable></option></arg>
      <arg choice='opt'><option>--profiles=<replaceable>filename</replaceable></option></arg>
      <arg choice='opt'><option>--translations=<replaceable>filename</replaceable></option></arg>
      <arg choice='opt'><option>--exact-nodes-only</option></arg>
      <arg choice='opt'><option>--quiet</option></arg>
      <arg choice='opt'><option>--loggable</option></arg>
      <arg choice='opt'><option>--logtime</option></arg>
      <arg choice='opt'><option>--logmemory</option></arg>
      <arg choice='opt'><option>--language=<replaceable>lang</replaceable></option></arg>
      <arg choice='opt'><option>--output-html</option></arg>
      <arg choice='opt'><option>--output-gpx-track</option></arg>
      <arg choice='opt'><option>--output-gpx-route</option></arg>
      <arg choice='opt'><option>--output-text</option></arg>
      <arg choice='opt'><option>--output-text-all</option></arg>
      <arg choice='opt'><option>--output-none</option></arg>
      <arg choice='opt'><option>--output-stdout</option></arg>
      <arg choice='opt'><option>--profile=<replaceable>name</replaceable></option></arg>
      <arg choice='opt'><option>--transport=<replaceable>transport</replaceable></option></arg>
      <group>
        <arg choice='opt'><option>--shortest</option></arg>
        <arg choice='opt'><option>--quickest</option></arg>
      </group>
      <arg choice='plain'><option>--lon1=<replaceable>longitude</replaceable></option> <option>--lat1=<replaceable>latitude</replaceable></option></arg>
      <arg choice='plain'><option>--lon2=<replaceable>longitude</replaceable></option> <option>--lat2=<replaceable>latitude</replaceable></option></arg>
      <arg choice='opt'>... <option>--lon99=<replaceable>longitude</replaceable></option> <option>--lat99=<replaceable>latitude</replaceable></option></arg>
      <arg choice='opt'><option>--reverse</option></arg>
      <arg choice='opt'><option>--loop</option></arg>
      <arg choice='opt'><option>--highway-&lt;highway&gt;=<replaceable>preference</replaceable></option> ...</arg>
      <arg choice='opt'><option>--speed-&lt;highway&gt;=<replaceable>speed</replaceable></option> ...</arg>
      <arg choice='opt'><option>--property-&lt;property&gt;=<replaceable>preference</replaceable></option> ...</arg>
      <arg choice='opt'><option>--oneway=<replaceable>0|1</replaceable></option></arg>
      <arg choice='opt'><option>--turns=<replaceable>0|1</replaceable></option></arg>
      <arg choice='opt'><option>--weight=<replaceable>weight</replaceable></option></arg>
      <arg choice='opt'><option>--height=<replaceable>height</replaceable></option></arg>
      <arg choice='opt'><option>--width=<replaceable>width</replaceable></option></arg>
      <arg choice='opt'><option>--length=<replaceable>length</replaceable></option></arg>
    </cmdsynopsis>
  </refsynopsisdiv>

  <refsect1 id='description'>
    <title>DESCRIPTION</title>
    <para>
      <command>routino-router-slim</command> performs the calculation of the
      optimum routes using the database generated by the
      <citerefentry>
        <refentrytitle>planetsplitter</refentrytitle>
        <manvolnum>1</manvolnum>
      </citerefentry>
      program.
    </para>
  </refsect1>

  <refsect1 id='options'>
    <title>OPTIONS</title>
    <variablelist>

      <varlistentry>
        <term><option>--version</option></term>
        <listitem>
          <para>
            Print the version of Routino.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--help</option></term>
        <listitem>
          <para>
            Prints out the help information.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--help-profile</option></term>
        <listitem>
          <para>
            Prints out the selected transport profile
            (type, speed limits, highway preferences etc.)
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--help-profile-xml</option></term>
        <listitem>
          <para>
            Prints out all the loaded profiles as an XML file in the same
            format that can be loaded in.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--help-profile-json</option></term>
        <listitem>
          <para>
            Prints out all the loaded profiles in JavaScript Object Notation
            (JSON) format for use in the interactive webpage.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--help-profile-perl</option></term>
        <listitem>
          <para>
            Prints out all the loaded profiles as a Perl object for use in
            the router CGI.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--dir</option>=<replaceable>dirname</replaceable></term>
        <listitem>
          <para>
            Sets the directory name in which to read the local database.
            Defaults to the current directory.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--prefix</option>=<replaceable>name</replaceable></term>
        <listitem>
          <para>
            Sets the filename prefix for the files in the local database.
            Defaults to no prefix.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--profiles</option>=<replaceable>filename</replaceable></term>
        <listitem>
          <para>
            Sets the filename containing the list of routing profiles in XML
            format.
            If the file doesn't exist then <option>--dirname</option>,
            <option>--prefix</option> and "profiles.xml" will be combined and
            used, if that doesn't exist then the file
            <filename>/usr/share/routino/profiles.xml</filename>
            (or custom installation location) will be used.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--translations</option>=<replaceable>filename</replaceable></term>
        <listitem>
          <para>
            Sets the filename containing the list of translations in XML
            format for the output files.
            If the file doesn't exist then <option>--dirname</option>, 
            <option>--prefix</option> and "translations.xml" will be combined
            and used, if that doesn't exist then the file
            <filename>/usr/share/routino/translations.xml</filename>
            (or custom installation location) will be used.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--exact-nodes-only</option></term>
        <listitem>
          <para>
            When processing the specified latitude and longitude points only
            select the nearest node instead of finding the nearest point
            within a segment (quicker but less accurate unless the points are
            already near nodes).
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--quiet</option></term>
        <listitem>
          <para>
            Don't generate any screen output while running
            (useful for running in a script).
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--loggable</option></term>
        <listitem>
          <para>
            Print progress messages that are suitable for logging to a file;
            normally an incrementing counter is printed which is more suitable
            for real-time display than logging.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--logtime</option></term>
        <listitem>
          <para>
            Print the elapsed time for each processing step
            (minutes, seconds and milliseconds).
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--logmemory</option></term>
        <listitem>
          <para>
            Print the maximum allocated and mapped memory for each processing
            step (MBytes).
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--language</option>=<replaceable>lang</replaceable></term>
        <listitem>
          <para>
            Select the language specified from the file of translations.
            If this option is not given and the file exists then the first
            language in the file will be used.
            If this option is not given and no file exists the compiled-in
            default language (English) will be used.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--output-html</option></term>
        <term><option>--output-gpx-track</option></term>
        <term><option>--output-gpx-route</option></term>
        <term><option>--output-text</option></term>
        <term><option>--output-text-all</option></term>
        <listitem>
          <para>
            Generate the selected output file formats (HTML, GPX track file,
            GPX route file, plain text route and/or plain text with all nodes).
            If no output is specified then all are generated, specifying any
            automatically disables those not specified.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--output-none</option></term>
        <listitem>
          <para>
            Do not generate any output or read in any translations files.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--output-stdout</option></term>
        <listitem>
          <para>
            Write to stdout instead of a file (requires exactly one output
            format option, implies <option>--quiet</option>).
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--profile</option>=<replaceable>name</replaceable></term>
        <listitem>
          <para>
            Specifies the name of the profile to use.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--transport</option>=<replaceable>transport</replaceable></term>
        <listitem>
          <para>
            Select the type of transport to use, <replaceable>transport</replaceable> can be set to:
            <informaltable frame='none' colsep='0' rowsep='0'>
              <tgroup cols='3'>
               <tbody>
                 <row>
                   <entry>foot</entry>
                   <entry>=</entry>
                   <entry>Foot</entry>
                 </row>
                 <row>
                   <entry>horse</entry>
                   <entry>=</entry>
                   <entry>Horse</entry>
                 </row>
                 <row>
                   <entry>wheelchair</entry>
                   <entry>=</entry>
                   <entry>Wheelchair</entry>
                 </row>
                 <row>
                   <entry>bicycle</entry>
                   <entry>=</entry>
                   <entry>Bicycle</entry>
                 </row>
                 <row>
                   <entry>moped</entry>
                   <entry>=</entry>
                   <entry>Moped (Small motorcycle, limited speed)</entry>
                 </row>
                 <row>
                   <entry>motorcycle</entry>
                   <entry>=</entry>
                   <entry>Motorcycle</entry>
                 </row>
                 <row>
                   <entry>motorcar</entry>
                   <entry>=</entry>
                   <entry>Motorcar</entry>
                 </row>
                 <row>
                   <entry>goods</entry>
                   <entry>=</entry>
                   <entry>Goods (Small lorry, van)</entry>
                 </row>
                 <row>
                   <entry>hgv</entry>
                   <entry>=</entry>
                   <entry>HGV (Heavy Goods Vehicle \- large lorry)</entry>
                 </row>
                 <row>
                   <entry>psv</entry>
                   <entry>=</entry>
                   <entry>PSV (Public Service Vehicle \- bus, coach)</entry>
                 </row>
               </tbody>
              </tgroup>
            </informaltable>
          </para>
          <para>
            Defaults to 'motorcar', this option also selects the default
            profile information if the <option>--profile</option> option is
            not given and a profile matching the transport name is found.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--shortest</option></term>
        <listitem>
          <para>
            Find the shortest route between the waypoints.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--quickest</option></term>
        <listitem>
          <para>
            Find the quickest route between the waypoints.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--lon1</option>=<replaceable>longitude</replaceable></term>
        <term><option>--lat1</option>=<replaceable>latitude</replaceable></term>
        <term><option>--lon2</option>=<replaceable>longitude</replaceable></term>
        <term><option>--lat2</option>=<replaceable>latitude</replaceable></term>
        <term>... <option>--lon99</option>=<replaceable>longitude</replaceable></term>
        <term><option>--lat99</option>=<replaceable>latitude</replaceable></term>
        <listitem>
          <para>
            The location of the waypoints that make up the start, middle and
            end points of the route. Up to 99 waypoints can be specified and
            the route will pass through each of the specified ones in sequence.
            The algorithm will use the closest node or point within a segment
            that allows the specified traffic type.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--reverse</option></term>
        <listitem>
          <para>
            Find a route between the waypoints in reverse order.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--loop</option></term>
        <listitem>
          <para>
            Find a route that returns to the first waypoint after the last one.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--heading</option>=<replaceable>bearing</replaceable></term>
        <listitem>
          <para>
            Specifies the initial direction of travel at the start of the
            route (from the lowest numbered waypoint) as a compass bearing
            from 0 to 360 degrees.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--highway-&lt;highway&gt;</option>=<replaceable>preference</replaceable></term>
        <listitem>
          <para>
            Selects the percentage preference for using each particular type
            of highway.
            The value of <replaceable>highway</replaceable> can be selected
            from:
            <informaltable frame='none' colsep='0' rowsep='0'>
              <tgroup cols='3'>
               <tbody>
                 <row>
                   <entry>motorway</entry>
                   <entry>=</entry>
                   <entry>Motorway</entry>
                 </row>
                 <row>
                   <entry>trunk</entry>
                   <entry>=</entry>
                   <entry>Trunk</entry>
                 </row>
                 <row>
                   <entry>primary</entry>
                   <entry>=</entry>
                   <entry>Primary</entry>
                 </row>
                 <row>
                   <entry>secondary</entry>
                   <entry>=</entry>
                   <entry>Secondary</entry>
                 </row>
                 <row>
                   <entry>tertiary</entry>
                   <entry>=</entry>
                   <entry>Tertiary</entry>
                 </row>
                 <row>
                   <entry>unclassified</entry>
                   <entry>=</entry>
                   <entry>Unclassified</entry>
                 </row>
                 <row>
                   <entry>residential</entry>
                   <entry>=</entry>
                   <entry>Residential</entry>
                 </row>
                 <row>
                   <entry>service</entry>
                   <entry>=</entry>
                   <entry>Service</entry>
                 </row>
                 <row>
                   <entry>track</entry>
                   <entry>=</entry>
                   <entry>Track</entry>
                 </row>
                 <row>
                   <entry>cycleway</entry>
                   <entry>=</entry>
                   <entry>Cycleway</entry>
                 </row>
                 <row>
                   <entry>path</entry>
                   <entry>=</entry>
                   <entry>Path</entry>
                 </row>
                 <row>
                   <entry>steps</entry>
                   <entry>=</entry>
                   <entry>Steps</entry>
                 </row>
                 <row>
                   <entry>ferry</entry>
                   <entry>=</entry>
                   <entry>Ferry</entry>
                 </row>
               </tbody>
              </tgroup>
            </informaltable>
          </para>
          <para>
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--speed-&lt;highway&gt;</option>=<replaceable>speed</replaceable></term>
        <listitem>
          <para>
            Selects the speed limit in km/hour for each type of highway.
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--property-&lt;property&gt;</option>=<replaceable>preference</replaceable></term>
        <listitem>
          <para>
            Selects the percentage preference for using each particular
            highway property.
            The value of <replaceable>property</replaceable> can be selected
            from:
            <informaltable frame='none' colsep='0' rowsep='0'>
              <tgroup cols='3'>
               <tbody>
                 <row>
                   <entry>paved</entry>
                   <entry>=</entry>
                   <entry>Paved (suitable for normal wheels)</entry>
                 </row>
                 <row>
                   <entry>multilane</entry>
                   <entry>=</entry>
                   <entry>Multiple lanes</entry>
                 </row>
                 <row>
                   <entry>bridge</entry>
                   <entry>=</entry>
                   <entry>Bridge</entry>
                 </row>
                 <row>
                   <entry>tunnel</entry>
                   <entry>=</entry>
                   <entry>Tunnel</entry>
                 </row>
                 <row>
                   <entry>footroute</entry>
                   <entry>=</entry>
                   <entry>A route marked for foot travel</entry>
                 </row>
                 <row>
                   <entry>bicycleroute</entry>
                   <entry>=</entry>
                   <entry>A route marked for bicycle travel</entry>
                 </row>
               </tbody>
              </tgroup>
            </informaltable>
          </para>
          <para>
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--oneway=</option>=<replaceable>0|1</replaceable></term>
        <listitem>
          <para>
            Selects if the direction of oneway streets are to be obeyed
            (useful to not obey them when walking).
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--turns=</option>=<replaceable>0|1</replaceable></term>
        <listitem>
          <para>
            Selects if turn restrictions are to be obeyed (useful to not obey
            them when walking).
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--weight</option>=<replaceable>weight</replaceable></term>
        <listitem>
          <para>
            Specifies the weight of the mode of transport in tonnes; ensures
            that the weight limit on the highway is not exceeded.
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--height</option>=<replaceable>height</replaceable></term>
        <listitem>
          <para>
            Specifies the height of the mode of transport in metres; ensures
            that the height limit on the highway is not exceeded.
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--width</option>=<replaceable>width</replaceable></term>
        <listitem>
          <para>
            Specifies the width of the mode of transport in metres; ensures
            that the width limit on the highway is not exceeded.
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term><option>--length</option>=<replaceable>length</replaceable></term>
        <listitem>
          <para>
            Specifies the length of the mode of transport in metres; ensures
            that the length limit on the highway is not exceeded.
            Default value depends on the profile selected by the
            <option>--transport</option> option.
          </para>
        </listitem>
      </varlistentry>

    </variablelist>

    <para>
      The meaning of the <replaceable>preference</replaceable> parameter in
      the command line options is slightly different for the highway
      preferences and the property preferences.
      For the highway preference consider the choice between two possible
      highways between the start and finish when looking for the shortest
      route.
      If highway A has a preference of 100% and highway B has a preference of
      90% then highway A will be chosen even if it is up to 11% longer
      (100/90 = 111%).
      For the highway properties each highway either has a particular property
      or not.
      If the preference for the property is 60% then a highway with the
      property has a preference of 77% (sqrt(60%)) and one without has a
      preference of 63% (sqrt(100-60%)).
      A highway with the property will be chosen even if it is up to 22%
      longer than one without the property (77/63 = 122%).
      The overall preference for each highway segment is the product of the
      preference for the highway type and all of the preferences for the
      highway properties.
    </para>

  </refsect1>

  <refsect1 id='examples'>
    <title>EXAMPLES</title>

    <example>
      <para>
        Example usage (motorcycle journey, scenic route, not very fast):
      </para>
      <screen>
<command>routino-router-slim</command> <option>--dir</option>=<filename>data</filename> <option>--prefix</option>=gb <option>--transport</option>=motorcycle \
                    <option>--highway-motorway</option>=0 <option>--highway-trunk</option>=0 \
                    <option>--speed-primary</option>=80 <option>--speed-secondary</option>=80 \
                    <option>--quickest</option>
      </screen>
      <para>
        This will use the files
        <filename>data/gb-nodes.mem</filename>,
        <filename>data/gb-segments.mem</filename> and
        <filename>data/gb-ways.mem</filename> to find the quickest route by
        motorcycle not using motorways or trunk roads and not exceeding 80
        km/hr.
      </para>
    </example>

  </refsect1>

</refentry>
